//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PSmsChild_h
#define PSmsChild_h

#include "mozilla/dom/sms/PSms.h"
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace sms {


class /*NS_ABSTRACT_CLASS*/ PSmsChild :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::dom::PContentChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PSms::State State;

    virtual bool
    RecvNotifyReceivedMessage(const SmsMessageData& aMessageData) = 0;
    virtual bool
    RecvNotifySentMessage(const SmsMessageData& aMessageData) = 0;
    virtual bool
    RecvNotifyDeliveredMessage(const SmsMessageData& aMessageData) = 0;
    virtual bool
    RecvNotifyRequestSmsSent(
            const SmsMessageData& aMessageData,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId) = 0;
    virtual bool
    RecvNotifyRequestSmsSendFailed(
            const PRInt32& aError,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId) = 0;
    virtual bool
    RecvNotifyRequestGotSms(
            const SmsMessageData& aMessageData,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId) = 0;
    virtual bool
    RecvNotifyRequestGetSmsFailed(
            const PRInt32& aError,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId) = 0;
    virtual bool
    RecvNotifyRequestSmsDeleted(
            const bool& aDeleted,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId) = 0;
    virtual bool
    RecvNotifyRequestSmsDeleteFailed(
            const PRInt32& aError,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId) = 0;
    virtual bool
    RecvNotifyRequestNoMessageInList(
            const PRInt32& aRequestId,
            const PRUint64& aProcessId) = 0;
    virtual bool
    RecvNotifyRequestCreateMessageList(
            const PRInt32& aListId,
            const SmsMessageData& aMessageData,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId) = 0;
    virtual bool
    RecvNotifyRequestGotNextMessage(
            const SmsMessageData& aMessageData,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId) = 0;
    virtual bool
    RecvNotifyRequestReadListFailed(
            const PRInt32& aError,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PSmsChild();

    virtual ~PSmsChild();

    PContentChild*
    Manager();

    PSms::State
    state();

    bool
    SendHasSupport(bool* aHasSupport);

    bool
    SendGetNumberOfMessagesForText(
            const nsString& aText,
            PRUint16* aNumber);

    bool
    SendSendMessage(
            const nsString& aNumber,
            const nsString& aMessage,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    bool
    SendSaveSentMessage(
            const nsString& aReceiver,
            const nsString& aBody,
            const PRUint64& aDate,
            PRInt32* aId);

    bool
    SendGetMessage(
            const PRInt32& aMessageId,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    bool
    SendDeleteMessage(
            const PRInt32& aMessageId,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    bool
    SendCreateMessageList(
            const SmsFilterData& aFilter,
            const bool& aReverse,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    bool
    SendGetNextMessageInList(
            const PRInt32& aListId,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    bool
    SendClearMessageList(const PRInt32& aListId);

    static bool
    Send__delete__(PSmsChild* actor);

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const SmsMessageData& __v,
            Message* __msg);

    bool
    Read(
            SmsMessageData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SmsFilterData& __v,
            Message* __msg);

    bool
    Read(
            SmsFilterData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PSmsChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PSmsChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace sms
} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
namespace sms {
class SmsChild :
    public PSmsChild
{
    virtual bool
    RecvNotifyReceivedMessage(const SmsMessageData& aMessageData);

    virtual bool
    RecvNotifySentMessage(const SmsMessageData& aMessageData);

    virtual bool
    RecvNotifyDeliveredMessage(const SmsMessageData& aMessageData);

    virtual bool
    RecvNotifyRequestSmsSent(
            const SmsMessageData& aMessageData,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    virtual bool
    RecvNotifyRequestSmsSendFailed(
            const PRInt32& aError,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    virtual bool
    RecvNotifyRequestGotSms(
            const SmsMessageData& aMessageData,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    virtual bool
    RecvNotifyRequestGetSmsFailed(
            const PRInt32& aError,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    virtual bool
    RecvNotifyRequestSmsDeleted(
            const bool& aDeleted,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    virtual bool
    RecvNotifyRequestSmsDeleteFailed(
            const PRInt32& aError,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    virtual bool
    RecvNotifyRequestNoMessageInList(
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    virtual bool
    RecvNotifyRequestCreateMessageList(
            const PRInt32& aListId,
            const SmsMessageData& aMessageData,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    virtual bool
    RecvNotifyRequestGotNextMessage(
            const SmsMessageData& aMessageData,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    virtual bool
    RecvNotifyRequestReadListFailed(
            const PRInt32& aError,
            const PRInt32& aRequestId,
            const PRUint64& aProcessId);

    SmsChild();
    virtual ~SmsChild();
};
} // namespace sms
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
namespace sms {
bool
SmsChild::RecvNotifyReceivedMessage(const SmsMessageData& aMessageData)
{
    return false;
}

bool
SmsChild::RecvNotifySentMessage(const SmsMessageData& aMessageData)
{
    return false;
}

bool
SmsChild::RecvNotifyDeliveredMessage(const SmsMessageData& aMessageData)
{
    return false;
}

bool
SmsChild::RecvNotifyRequestSmsSent(
        const SmsMessageData& aMessageData,
        const PRInt32& aRequestId,
        const PRUint64& aProcessId)
{
    return false;
}

bool
SmsChild::RecvNotifyRequestSmsSendFailed(
        const PRInt32& aError,
        const PRInt32& aRequestId,
        const PRUint64& aProcessId)
{
    return false;
}

bool
SmsChild::RecvNotifyRequestGotSms(
        const SmsMessageData& aMessageData,
        const PRInt32& aRequestId,
        const PRUint64& aProcessId)
{
    return false;
}

bool
SmsChild::RecvNotifyRequestGetSmsFailed(
        const PRInt32& aError,
        const PRInt32& aRequestId,
        const PRUint64& aProcessId)
{
    return false;
}

bool
SmsChild::RecvNotifyRequestSmsDeleted(
        const bool& aDeleted,
        const PRInt32& aRequestId,
        const PRUint64& aProcessId)
{
    return false;
}

bool
SmsChild::RecvNotifyRequestSmsDeleteFailed(
        const PRInt32& aError,
        const PRInt32& aRequestId,
        const PRUint64& aProcessId)
{
    return false;
}

bool
SmsChild::RecvNotifyRequestNoMessageInList(
        const PRInt32& aRequestId,
        const PRUint64& aProcessId)
{
    return false;
}

bool
SmsChild::RecvNotifyRequestCreateMessageList(
        const PRInt32& aListId,
        const SmsMessageData& aMessageData,
        const PRInt32& aRequestId,
        const PRUint64& aProcessId)
{
    return false;
}

bool
SmsChild::RecvNotifyRequestGotNextMessage(
        const SmsMessageData& aMessageData,
        const PRInt32& aRequestId,
        const PRUint64& aProcessId)
{
    return false;
}

bool
SmsChild::RecvNotifyRequestReadListFailed(
        const PRInt32& aError,
        const PRInt32& aRequestId,
        const PRUint64& aProcessId)
{
    return false;
}

SmsChild::SmsChild()
{
    MOZ_COUNT_CTOR(SmsChild);
}

SmsChild::~SmsChild()
{
    MOZ_COUNT_DTOR(SmsChild);
}

} // namespace sms
} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PSmsChild_h
