//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHal_h
#define PHal_h

#include "mozilla/Attributes.h"
#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BatteryInformation|
//
namespace mozilla {
namespace hal {
class BatteryInformation MOZ_FINAL
{
private:

public:
    BatteryInformation();

    BatteryInformation(
            const double& _level,
            const bool& _charging,
            const double& _remainingTime)
    {
        Init();
        Assign(_level, _charging, _remainingTime);
    }

    BatteryInformation(const BatteryInformation& _o)
    {
        Init();
        Assign((_o).level(), (_o).charging(), (_o).remainingTime());
    }

    ~BatteryInformation();

    void
    operator=(const BatteryInformation& _o)
    {
        Assign((_o).level(), (_o).charging(), (_o).remainingTime());
    }

    bool
    operator==(const BatteryInformation& _o) const;

    double&
    level()
    {
        return level_;
    }
    const double&
    level() const
    {
        return level_;
    }

    bool&
    charging()
    {
        return charging_;
    }
    const bool&
    charging() const
    {
        return charging_;
    }

    double&
    remainingTime()
    {
        return remainingTime_;
    }
    const double&
    remainingTime() const
    {
        return remainingTime_;
    }

private:
    void
    Init();

    void
    Assign(
            const double& _level,
            const bool& _charging,
            const double& _remainingTime);

    double level_;
    bool charging_;
    double remainingTime_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NetworkInformation|
//
namespace mozilla {
namespace hal {
class NetworkInformation MOZ_FINAL
{
private:

public:
    NetworkInformation();

    NetworkInformation(
            const double& _bandwidth,
            const bool& _canBeMetered)
    {
        Init();
        Assign(_bandwidth, _canBeMetered);
    }

    NetworkInformation(const NetworkInformation& _o)
    {
        Init();
        Assign((_o).bandwidth(), (_o).canBeMetered());
    }

    ~NetworkInformation();

    void
    operator=(const NetworkInformation& _o)
    {
        Assign((_o).bandwidth(), (_o).canBeMetered());
    }

    bool
    operator==(const NetworkInformation& _o) const;

    double&
    bandwidth()
    {
        return bandwidth_;
    }
    const double&
    bandwidth() const
    {
        return bandwidth_;
    }

    bool&
    canBeMetered()
    {
        return canBeMetered_;
    }
    const bool&
    canBeMetered() const
    {
        return canBeMetered_;
    }

private:
    void
    Init();

    void
    Assign(
            const double& _bandwidth,
            const bool& _canBeMetered);

    double bandwidth_;
    bool canBeMetered_;
};
} // namespace hal
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PHalChild and PHalParent
//
namespace mozilla {
namespace hal_sandbox {
namespace PHal {

enum State {
    __Dead,
    __Null,
    __Error,
    __Start = __Null
};

enum MessageType {
    PHalStart = PHalMsgStart << 16,
    PHalPreStart = (PHalMsgStart << 16) - 1,
    Msg_NotifyBatteryChange__ID,
    Msg_NotifyNetworkChange__ID,
    Msg_Vibrate__ID,
    Msg_CancelVibrate__ID,
    Msg_EnableBatteryNotifications__ID,
    Msg_DisableBatteryNotifications__ID,
    Msg_GetCurrentBatteryInformation__ID,
    Reply_GetCurrentBatteryInformation__ID,
    Msg_EnableNetworkNotifications__ID,
    Msg_DisableNetworkNotifications__ID,
    Msg_GetCurrentNetworkInformation__ID,
    Reply_GetCurrentNetworkInformation__ID,
    Msg_GetScreenEnabled__ID,
    Reply_GetScreenEnabled__ID,
    Msg_SetScreenEnabled__ID,
    Msg_GetScreenBrightness__ID,
    Reply_GetScreenBrightness__ID,
    Msg_SetScreenBrightness__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PHalEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_NotifyBatteryChange :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyBatteryChange__ID
    };
    Msg_NotifyBatteryChange() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_NotifyBatteryChange")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyBatteryChange(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyNetworkChange :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyNetworkChange__ID
    };
    Msg_NotifyNetworkChange() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_NotifyNetworkChange")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyNetworkChange(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Vibrate :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Vibrate__ID
    };
    Msg_Vibrate() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_Vibrate")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Vibrate(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_CancelVibrate :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_CancelVibrate__ID
    };
    Msg_CancelVibrate() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_CancelVibrate")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_CancelVibrate(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_EnableBatteryNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_EnableBatteryNotifications__ID
    };
    Msg_EnableBatteryNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_EnableBatteryNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_EnableBatteryNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_DisableBatteryNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_DisableBatteryNotifications__ID
    };
    Msg_DisableBatteryNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_DisableBatteryNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_DisableBatteryNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetCurrentBatteryInformation :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_GetCurrentBatteryInformation__ID
    };
    Msg_GetCurrentBatteryInformation() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_GetCurrentBatteryInformation")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetCurrentBatteryInformation(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetCurrentBatteryInformation :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_GetCurrentBatteryInformation__ID
    };
    Reply_GetCurrentBatteryInformation() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_GetCurrentBatteryInformation")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetCurrentBatteryInformation(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_EnableNetworkNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_EnableNetworkNotifications__ID
    };
    Msg_EnableNetworkNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_EnableNetworkNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_EnableNetworkNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_DisableNetworkNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_DisableNetworkNotifications__ID
    };
    Msg_DisableNetworkNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_DisableNetworkNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_DisableNetworkNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetCurrentNetworkInformation :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_GetCurrentNetworkInformation__ID
    };
    Msg_GetCurrentNetworkInformation() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_GetCurrentNetworkInformation")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetCurrentNetworkInformation(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetCurrentNetworkInformation :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_GetCurrentNetworkInformation__ID
    };
    Reply_GetCurrentNetworkInformation() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_GetCurrentNetworkInformation")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetCurrentNetworkInformation(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetScreenEnabled :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_GetScreenEnabled__ID
    };
    Msg_GetScreenEnabled() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_GetScreenEnabled")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetScreenEnabled(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetScreenEnabled :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_GetScreenEnabled__ID
    };
    Reply_GetScreenEnabled() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_GetScreenEnabled")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetScreenEnabled(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SetScreenEnabled :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_SetScreenEnabled__ID
    };
    Msg_SetScreenEnabled() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_SetScreenEnabled")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetScreenEnabled(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetScreenBrightness :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_GetScreenBrightness__ID
    };
    Msg_GetScreenBrightness() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_GetScreenBrightness")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetScreenBrightness(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetScreenBrightness :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_GetScreenBrightness__ID
    };
    Reply_GetScreenBrightness() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_GetScreenBrightness")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetScreenBrightness(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SetScreenBrightness :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_SetScreenBrightness__ID
    };
    Msg_SetScreenBrightness() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_SetScreenBrightness")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetScreenBrightness(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg___delete____ID
    };
    Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply___delete____ID
    };
    Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PHal
} // namespace hal_sandbox
} // namespace mozilla

#endif // ifndef PHal_h
