//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHttpChannelChild_h
#define PHttpChannelChild_h

#include "mozilla/net/PHttpChannel.h"
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PHttpChannelChild :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::net::PNeckoChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PHttpChannel::State State;

    virtual bool
    RecvOnStartRequest(
            const nsHttpResponseHead& responseHead,
            const bool& useResponseHead,
            const nsHttpHeaderArray& requestHeaders,
            const bool& isFromCache,
            const bool& cacheEntryAvailable,
            const PRUint32& cacheExpirationTime,
            const nsCString& cachedCharset,
            const nsCString& securityInfoSerialization,
            const PRNetAddr& selfAddr,
            const PRNetAddr& peerAddr) = 0;
    virtual bool
    RecvOnTransportAndData(
            const nsresult& status,
            const PRUint64& progress,
            const PRUint64& progressMax,
            const nsCString& data,
            const PRUint32& offset,
            const PRUint32& count) = 0;
    virtual bool
    RecvOnStopRequest(const nsresult& statusCode) = 0;
    virtual bool
    RecvOnProgress(
            const PRUint64& progress,
            const PRUint64& progressMax) = 0;
    virtual bool
    RecvOnStatus(const nsresult& status) = 0;
    virtual bool
    RecvFailedAsyncOpen(const nsresult& status) = 0;
    virtual bool
    RecvRedirect1Begin(
            const PRUint32& newChannelId,
            const URI& newUri,
            const PRUint32& redirectFlags,
            const nsHttpResponseHead& responseHead) = 0;
    virtual bool
    RecvRedirect3Complete() = 0;
    virtual bool
    RecvAssociateApplicationCache(
            const nsCString& groupID,
            const nsCString& clientID) = 0;
    virtual bool
    RecvDeleteSelf() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PHttpChannelChild();

    virtual ~PHttpChannelChild();

    PNeckoChild*
    Manager();

    PHttpChannel::State
    state();

    bool
    SendAsyncOpen(
            const URI& uri,
            const URI& original,
            const URI& doc,
            const URI& referrer,
            const PRUint32& loadFlags,
            const RequestHeaderTuples& requestHeaders,
            const nsHttpAtom& requestMethod,
            const InputStream& uploadStream,
            const bool& uploadStreamHasHeaders,
            const PRUint16& priority,
            const PRUint8& redirectionLimit,
            const bool& allowPipelining,
            const bool& forceAllowThirdPartyCookie,
            const bool& resumeAt,
            const PRUint64& startPos,
            const nsCString& entityID,
            const bool& chooseApplicationCache,
            const nsCString& appCacheClientID,
            const bool& allowSpdy);

    bool
    SendConnectChannel(const PRUint32& channelId);

    bool
    SendSetPriority(const PRUint16& priority);

    bool
    SendSetCacheTokenCachedCharset(const nsCString& charset);

    bool
    SendUpdateAssociatedContentSecurity(
            const PRInt32& high,
            const PRInt32& low,
            const PRInt32& broken,
            const PRInt32& no);

    bool
    SendSuspend();

    bool
    SendResume();

    bool
    SendCancel(const nsresult& status);

    bool
    SendRedirect2Verify(
            const nsresult& result,
            const RequestHeaderTuples& changedHeaders);

    bool
    SendDocumentChannelCleanup();

    bool
    SendMarkOfflineCacheEntryAsForeign();

    static bool
    Send__delete__(PHttpChannelChild* actor);

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PHttpChannelChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PHttpChannelChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class HttpChannelChild :
    public PHttpChannelChild
{
    virtual bool
    RecvOnStartRequest(
            const nsHttpResponseHead& responseHead,
            const bool& useResponseHead,
            const nsHttpHeaderArray& requestHeaders,
            const bool& isFromCache,
            const bool& cacheEntryAvailable,
            const PRUint32& cacheExpirationTime,
            const nsCString& cachedCharset,
            const nsCString& securityInfoSerialization,
            const PRNetAddr& selfAddr,
            const PRNetAddr& peerAddr);

    virtual bool
    RecvOnTransportAndData(
            const nsresult& status,
            const PRUint64& progress,
            const PRUint64& progressMax,
            const nsCString& data,
            const PRUint32& offset,
            const PRUint32& count);

    virtual bool
    RecvOnStopRequest(const nsresult& statusCode);

    virtual bool
    RecvOnProgress(
            const PRUint64& progress,
            const PRUint64& progressMax);

    virtual bool
    RecvOnStatus(const nsresult& status);

    virtual bool
    RecvFailedAsyncOpen(const nsresult& status);

    virtual bool
    RecvRedirect1Begin(
            const PRUint32& newChannelId,
            const URI& newUri,
            const PRUint32& redirectFlags,
            const nsHttpResponseHead& responseHead);

    virtual bool
    RecvRedirect3Complete();

    virtual bool
    RecvAssociateApplicationCache(
            const nsCString& groupID,
            const nsCString& clientID);

    virtual bool
    RecvDeleteSelf();

    HttpChannelChild();
    virtual ~HttpChannelChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
HttpChannelChild::RecvOnStartRequest(
        const nsHttpResponseHead& responseHead,
        const bool& useResponseHead,
        const nsHttpHeaderArray& requestHeaders,
        const bool& isFromCache,
        const bool& cacheEntryAvailable,
        const PRUint32& cacheExpirationTime,
        const nsCString& cachedCharset,
        const nsCString& securityInfoSerialization,
        const PRNetAddr& selfAddr,
        const PRNetAddr& peerAddr)
{
    return false;
}

bool
HttpChannelChild::RecvOnTransportAndData(
        const nsresult& status,
        const PRUint64& progress,
        const PRUint64& progressMax,
        const nsCString& data,
        const PRUint32& offset,
        const PRUint32& count)
{
    return false;
}

bool
HttpChannelChild::RecvOnStopRequest(const nsresult& statusCode)
{
    return false;
}

bool
HttpChannelChild::RecvOnProgress(
        const PRUint64& progress,
        const PRUint64& progressMax)
{
    return false;
}

bool
HttpChannelChild::RecvOnStatus(const nsresult& status)
{
    return false;
}

bool
HttpChannelChild::RecvFailedAsyncOpen(const nsresult& status)
{
    return false;
}

bool
HttpChannelChild::RecvRedirect1Begin(
        const PRUint32& newChannelId,
        const URI& newUri,
        const PRUint32& redirectFlags,
        const nsHttpResponseHead& responseHead)
{
    return false;
}

bool
HttpChannelChild::RecvRedirect3Complete()
{
    return false;
}

bool
HttpChannelChild::RecvAssociateApplicationCache(
        const nsCString& groupID,
        const nsCString& clientID)
{
    return false;
}

bool
HttpChannelChild::RecvDeleteSelf()
{
    return false;
}

HttpChannelChild::HttpChannelChild()
{
    MOZ_COUNT_CTOR(HttpChannelChild);
}

HttpChannelChild::~HttpChannelChild()
{
    MOZ_COUNT_DTOR(HttpChannelChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PHttpChannelChild_h
