//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBrowserStreamParent_h
#define PBrowserStreamParent_h

#include "mozilla/plugins/PBrowserStream.h"
namespace mozilla {
namespace plugins {
class PPluginInstanceParent;
} // namespace plugins
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace plugins {
class PPluginInstanceParent;
} // namespace plugins
} // namespace mozilla

namespace mozilla {
namespace plugins {


class /*NS_ABSTRACT_CLASS*/ PBrowserStreamParent :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::plugins::PPluginInstanceParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;
    typedef mozilla::plugins::PPluginInstanceParent PPluginInstanceParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PBrowserStream::State State;

    virtual bool
    AnswerNPN_RequestRead(
            const IPCByteRanges& ranges,
            NPError* result) = 0;
    virtual bool
    RecvNPN_DestroyStream(const NPReason& reason) = 0;
    virtual bool
    RecvStreamDestroyed() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PBrowserStreamParent();

    virtual ~PBrowserStreamParent();

    PPluginInstanceParent*
    Manager();

    PBrowserStream::State
    state();

    bool
    SendWrite(
            const int32_t& offset,
            const Buffer& data,
            const uint32_t& newlength) NS_WARN_UNUSED_RESULT;

    bool
    SendNPP_StreamAsFile(const nsCString& fname) NS_WARN_UNUSED_RESULT;

    bool
    SendNPP_DestroyStream(const NPReason& reason) NS_WARN_UNUSED_RESULT;

    static bool
    Send__delete__(PBrowserStreamParent* actor) NS_WARN_UNUSED_RESULT;

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PBrowserStreamParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PBrowserStreamParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace plugins
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace plugins {
class BrowserStreamParent :
    public PBrowserStreamParent
{
    virtual bool
    AnswerNPN_RequestRead(
            const IPCByteRanges& ranges,
            NPError* result);

    virtual bool
    RecvNPN_DestroyStream(const NPReason& reason);

    virtual bool
    RecvStreamDestroyed();

    BrowserStreamParent();
    virtual ~BrowserStreamParent();
};
} // namespace plugins
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace plugins {
bool
BrowserStreamParent::AnswerNPN_RequestRead(
        const IPCByteRanges& ranges,
        NPError* result)
{
    return false;
}

bool
BrowserStreamParent::RecvNPN_DestroyStream(const NPReason& reason)
{
    return false;
}

bool
BrowserStreamParent::RecvStreamDestroyed()
{
    return false;
}

BrowserStreamParent::BrowserStreamParent()
{
    MOZ_COUNT_CTOR(BrowserStreamParent);
}

BrowserStreamParent::~BrowserStreamParent()
{
    MOZ_COUNT_DTOR(BrowserStreamParent);
}

} // namespace plugins
} // namespace mozilla
#endif // if 0

#endif // ifndef PBrowserStreamParent_h
