/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "DictionaryHelpers.h"
#include "nsContentUtils.h"
#include "nsIXPConnect.h"
#include "nsIDOMEvent.h"
#include "nsIDOMCustomEvent.h"
#include "nsIDOMPopStateEvent.h"
#include "nsIDOMHashChangeEvent.h"
#include "nsIDOMPageTransitionEvent.h"
#include "nsIDOMCloseEvent.h"
#include "nsIDOMUIEvent.h"
#include "nsIDOMMouseEvent.h"
#include "nsIIDBDatabase.h"
#include "nsIIDBObjectStore.h"
#include "nsIVariant.h"
#include "nsIDOMWindow.h"
#include "nsIDOMEventTarget.h"

using namespace mozilla::dom;

static jsid gDictionary_id_bubbles = JSID_VOID;
static jsid gDictionary_id_cancelable = JSID_VOID;
static jsid gDictionary_id_detail = JSID_VOID;
static jsid gDictionary_id_state = JSID_VOID;
static jsid gDictionary_id_oldURL = JSID_VOID;
static jsid gDictionary_id_newURL = JSID_VOID;
static jsid gDictionary_id_persisted = JSID_VOID;
static jsid gDictionary_id_wasClean = JSID_VOID;
static jsid gDictionary_id_code = JSID_VOID;
static jsid gDictionary_id_reason = JSID_VOID;
static jsid gDictionary_id_view = JSID_VOID;
static jsid gDictionary_id_screenX = JSID_VOID;
static jsid gDictionary_id_screenY = JSID_VOID;
static jsid gDictionary_id_clientX = JSID_VOID;
static jsid gDictionary_id_clientY = JSID_VOID;
static jsid gDictionary_id_ctrlKey = JSID_VOID;
static jsid gDictionary_id_shiftKey = JSID_VOID;
static jsid gDictionary_id_altKey = JSID_VOID;
static jsid gDictionary_id_metaKey = JSID_VOID;
static jsid gDictionary_id_button = JSID_VOID;
static jsid gDictionary_id_relatedTarget = JSID_VOID;
static jsid gDictionary_id_keyPath = JSID_VOID;
static jsid gDictionary_id_autoIncrement = JSID_VOID;
static jsid gDictionary_id_unique = JSID_VOID;
static jsid gDictionary_id_multiEntry = JSID_VOID;

static bool
DefineStaticJSVal(JSContext* aCx, jsid &id, const char* aString)
{
  if (JSString* str = JS_InternString(aCx, aString)) {
    id = INTERNED_STRING_TO_JSID(aCx, str);
    return true;
  }
  return false;
}

bool
DefineStaticDictionaryJSVals(JSContext* aCx)
{
  JSAutoRequest ar(aCx);
  return
    DefineStaticJSVal(aCx, gDictionary_id_bubbles, "bubbles") &&
    DefineStaticJSVal(aCx, gDictionary_id_cancelable, "cancelable") &&
    DefineStaticJSVal(aCx, gDictionary_id_detail, "detail") &&
    DefineStaticJSVal(aCx, gDictionary_id_state, "state") &&
    DefineStaticJSVal(aCx, gDictionary_id_oldURL, "oldURL") &&
    DefineStaticJSVal(aCx, gDictionary_id_newURL, "newURL") &&
    DefineStaticJSVal(aCx, gDictionary_id_persisted, "persisted") &&
    DefineStaticJSVal(aCx, gDictionary_id_wasClean, "wasClean") &&
    DefineStaticJSVal(aCx, gDictionary_id_code, "code") &&
    DefineStaticJSVal(aCx, gDictionary_id_reason, "reason") &&
    DefineStaticJSVal(aCx, gDictionary_id_view, "view") &&
    DefineStaticJSVal(aCx, gDictionary_id_screenX, "screenX") &&
    DefineStaticJSVal(aCx, gDictionary_id_screenY, "screenY") &&
    DefineStaticJSVal(aCx, gDictionary_id_clientX, "clientX") &&
    DefineStaticJSVal(aCx, gDictionary_id_clientY, "clientY") &&
    DefineStaticJSVal(aCx, gDictionary_id_ctrlKey, "ctrlKey") &&
    DefineStaticJSVal(aCx, gDictionary_id_shiftKey, "shiftKey") &&
    DefineStaticJSVal(aCx, gDictionary_id_altKey, "altKey") &&
    DefineStaticJSVal(aCx, gDictionary_id_metaKey, "metaKey") &&
    DefineStaticJSVal(aCx, gDictionary_id_button, "button") &&
    DefineStaticJSVal(aCx, gDictionary_id_relatedTarget, "relatedTarget") &&
    DefineStaticJSVal(aCx, gDictionary_id_keyPath, "keyPath") &&
    DefineStaticJSVal(aCx, gDictionary_id_autoIncrement, "autoIncrement") &&
    DefineStaticJSVal(aCx, gDictionary_id_unique, "unique") &&
    DefineStaticJSVal(aCx, gDictionary_id_multiEntry, "multiEntry") &&
    true;
}

static nsresult
EventInit_InitInternal(EventInit& aDict, nsIEventInit* aIfaceObject, JSContext* aCx, JSObject* aObj)
{
  JSBool found = PR_FALSE;
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_bubbles, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetBubbles(&(aDict.bubbles));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_cancelable, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetCancelable(&(aDict.cancelable));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  return NS_OK;
}

nsresult
EventInit::Init(JSContext* aCx, const jsval* aVal)
{
  if (!aCx || !aVal) {
    return NS_OK;
  }
  NS_ENSURE_STATE(aVal->isObject());

  JSObject* obj = &aVal->toObject();
  nsCxPusher pusher;
  NS_ENSURE_STATE(pusher.Push(aCx, false));
  JSAutoRequest ar(aCx);
  JSAutoEnterCompartment ac;
  NS_ENSURE_STATE(ac.enter(aCx, obj));
  nsCOMPtr<nsIEventInit> dict;
  nsContentUtils::XPConnect()->WrapJS(aCx, obj,
                                      NS_GET_IID(nsIEventInit),
                                      getter_AddRefs(dict));
  NS_ENSURE_TRUE(dict, NS_OK);
  return EventInit_InitInternal(*this, dict, aCx, obj);
}

static nsresult
CustomEventInit_InitInternal(CustomEventInit& aDict, nsICustomEventInit* aIfaceObject, JSContext* aCx, JSObject* aObj)
{
  nsresult rv = EventInit_InitInternal(aDict, aIfaceObject, aCx, aObj);
  NS_ENSURE_SUCCESS(rv, rv);
  JSBool found = PR_FALSE;
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_detail, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetDetail(getter_AddRefs(aDict.detail));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  return NS_OK;
}

nsresult
CustomEventInit::Init(JSContext* aCx, const jsval* aVal)
{
  if (!aCx || !aVal) {
    return NS_OK;
  }
  NS_ENSURE_STATE(aVal->isObject());

  JSObject* obj = &aVal->toObject();
  nsCxPusher pusher;
  NS_ENSURE_STATE(pusher.Push(aCx, false));
  JSAutoRequest ar(aCx);
  JSAutoEnterCompartment ac;
  NS_ENSURE_STATE(ac.enter(aCx, obj));
  nsCOMPtr<nsICustomEventInit> dict;
  nsContentUtils::XPConnect()->WrapJS(aCx, obj,
                                      NS_GET_IID(nsICustomEventInit),
                                      getter_AddRefs(dict));
  NS_ENSURE_TRUE(dict, NS_OK);
  return CustomEventInit_InitInternal(*this, dict, aCx, obj);
}

static nsresult
PopStateEventInit_InitInternal(PopStateEventInit& aDict, nsIPopStateEventInit* aIfaceObject, JSContext* aCx, JSObject* aObj)
{
  nsresult rv = EventInit_InitInternal(aDict, aIfaceObject, aCx, aObj);
  NS_ENSURE_SUCCESS(rv, rv);
  JSBool found = PR_FALSE;
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_state, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetState(getter_AddRefs(aDict.state));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  return NS_OK;
}

nsresult
PopStateEventInit::Init(JSContext* aCx, const jsval* aVal)
{
  if (!aCx || !aVal) {
    return NS_OK;
  }
  NS_ENSURE_STATE(aVal->isObject());

  JSObject* obj = &aVal->toObject();
  nsCxPusher pusher;
  NS_ENSURE_STATE(pusher.Push(aCx, false));
  JSAutoRequest ar(aCx);
  JSAutoEnterCompartment ac;
  NS_ENSURE_STATE(ac.enter(aCx, obj));
  nsCOMPtr<nsIPopStateEventInit> dict;
  nsContentUtils::XPConnect()->WrapJS(aCx, obj,
                                      NS_GET_IID(nsIPopStateEventInit),
                                      getter_AddRefs(dict));
  NS_ENSURE_TRUE(dict, NS_OK);
  return PopStateEventInit_InitInternal(*this, dict, aCx, obj);
}

static nsresult
HashChangeEventInit_InitInternal(HashChangeEventInit& aDict, nsIHashChangeEventInit* aIfaceObject, JSContext* aCx, JSObject* aObj)
{
  nsresult rv = EventInit_InitInternal(aDict, aIfaceObject, aCx, aObj);
  NS_ENSURE_SUCCESS(rv, rv);
  JSBool found = PR_FALSE;
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_oldURL, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetOldURL(aDict.oldURL);
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_newURL, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetNewURL(aDict.newURL);
    NS_ENSURE_SUCCESS(rv, rv);
  }
  return NS_OK;
}

nsresult
HashChangeEventInit::Init(JSContext* aCx, const jsval* aVal)
{
  if (!aCx || !aVal) {
    return NS_OK;
  }
  NS_ENSURE_STATE(aVal->isObject());

  JSObject* obj = &aVal->toObject();
  nsCxPusher pusher;
  NS_ENSURE_STATE(pusher.Push(aCx, false));
  JSAutoRequest ar(aCx);
  JSAutoEnterCompartment ac;
  NS_ENSURE_STATE(ac.enter(aCx, obj));
  nsCOMPtr<nsIHashChangeEventInit> dict;
  nsContentUtils::XPConnect()->WrapJS(aCx, obj,
                                      NS_GET_IID(nsIHashChangeEventInit),
                                      getter_AddRefs(dict));
  NS_ENSURE_TRUE(dict, NS_OK);
  return HashChangeEventInit_InitInternal(*this, dict, aCx, obj);
}

static nsresult
PageTransitionEventInit_InitInternal(PageTransitionEventInit& aDict, nsIPageTransitionEventInit* aIfaceObject, JSContext* aCx, JSObject* aObj)
{
  nsresult rv = EventInit_InitInternal(aDict, aIfaceObject, aCx, aObj);
  NS_ENSURE_SUCCESS(rv, rv);
  JSBool found = PR_FALSE;
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_persisted, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetPersisted(&(aDict.persisted));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  return NS_OK;
}

nsresult
PageTransitionEventInit::Init(JSContext* aCx, const jsval* aVal)
{
  if (!aCx || !aVal) {
    return NS_OK;
  }
  NS_ENSURE_STATE(aVal->isObject());

  JSObject* obj = &aVal->toObject();
  nsCxPusher pusher;
  NS_ENSURE_STATE(pusher.Push(aCx, false));
  JSAutoRequest ar(aCx);
  JSAutoEnterCompartment ac;
  NS_ENSURE_STATE(ac.enter(aCx, obj));
  nsCOMPtr<nsIPageTransitionEventInit> dict;
  nsContentUtils::XPConnect()->WrapJS(aCx, obj,
                                      NS_GET_IID(nsIPageTransitionEventInit),
                                      getter_AddRefs(dict));
  NS_ENSURE_TRUE(dict, NS_OK);
  return PageTransitionEventInit_InitInternal(*this, dict, aCx, obj);
}

static nsresult
CloseEventInit_InitInternal(CloseEventInit& aDict, nsICloseEventInit* aIfaceObject, JSContext* aCx, JSObject* aObj)
{
  nsresult rv = EventInit_InitInternal(aDict, aIfaceObject, aCx, aObj);
  NS_ENSURE_SUCCESS(rv, rv);
  JSBool found = PR_FALSE;
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_wasClean, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetWasClean(&(aDict.wasClean));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_code, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetCode(&(aDict.code));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_reason, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetReason(aDict.reason);
    NS_ENSURE_SUCCESS(rv, rv);
  }
  return NS_OK;
}

nsresult
CloseEventInit::Init(JSContext* aCx, const jsval* aVal)
{
  if (!aCx || !aVal) {
    return NS_OK;
  }
  NS_ENSURE_STATE(aVal->isObject());

  JSObject* obj = &aVal->toObject();
  nsCxPusher pusher;
  NS_ENSURE_STATE(pusher.Push(aCx, false));
  JSAutoRequest ar(aCx);
  JSAutoEnterCompartment ac;
  NS_ENSURE_STATE(ac.enter(aCx, obj));
  nsCOMPtr<nsICloseEventInit> dict;
  nsContentUtils::XPConnect()->WrapJS(aCx, obj,
                                      NS_GET_IID(nsICloseEventInit),
                                      getter_AddRefs(dict));
  NS_ENSURE_TRUE(dict, NS_OK);
  return CloseEventInit_InitInternal(*this, dict, aCx, obj);
}

static nsresult
UIEventInit_InitInternal(UIEventInit& aDict, nsIUIEventInit* aIfaceObject, JSContext* aCx, JSObject* aObj)
{
  nsresult rv = EventInit_InitInternal(aDict, aIfaceObject, aCx, aObj);
  NS_ENSURE_SUCCESS(rv, rv);
  JSBool found = PR_FALSE;
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_view, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetView(getter_AddRefs(aDict.view));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_detail, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetDetail(&(aDict.detail));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  return NS_OK;
}

nsresult
UIEventInit::Init(JSContext* aCx, const jsval* aVal)
{
  if (!aCx || !aVal) {
    return NS_OK;
  }
  NS_ENSURE_STATE(aVal->isObject());

  JSObject* obj = &aVal->toObject();
  nsCxPusher pusher;
  NS_ENSURE_STATE(pusher.Push(aCx, false));
  JSAutoRequest ar(aCx);
  JSAutoEnterCompartment ac;
  NS_ENSURE_STATE(ac.enter(aCx, obj));
  nsCOMPtr<nsIUIEventInit> dict;
  nsContentUtils::XPConnect()->WrapJS(aCx, obj,
                                      NS_GET_IID(nsIUIEventInit),
                                      getter_AddRefs(dict));
  NS_ENSURE_TRUE(dict, NS_OK);
  return UIEventInit_InitInternal(*this, dict, aCx, obj);
}

static nsresult
MouseEventInit_InitInternal(MouseEventInit& aDict, nsIMouseEventInit* aIfaceObject, JSContext* aCx, JSObject* aObj)
{
  nsresult rv = UIEventInit_InitInternal(aDict, aIfaceObject, aCx, aObj);
  NS_ENSURE_SUCCESS(rv, rv);
  JSBool found = PR_FALSE;
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_screenX, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetScreenX(&(aDict.screenX));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_screenY, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetScreenY(&(aDict.screenY));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_clientX, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetClientX(&(aDict.clientX));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_clientY, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetClientY(&(aDict.clientY));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_ctrlKey, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetCtrlKey(&(aDict.ctrlKey));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_shiftKey, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetShiftKey(&(aDict.shiftKey));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_altKey, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetAltKey(&(aDict.altKey));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_metaKey, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetMetaKey(&(aDict.metaKey));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_button, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetButton(&(aDict.button));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_relatedTarget, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetRelatedTarget(getter_AddRefs(aDict.relatedTarget));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  return NS_OK;
}

nsresult
MouseEventInit::Init(JSContext* aCx, const jsval* aVal)
{
  if (!aCx || !aVal) {
    return NS_OK;
  }
  NS_ENSURE_STATE(aVal->isObject());

  JSObject* obj = &aVal->toObject();
  nsCxPusher pusher;
  NS_ENSURE_STATE(pusher.Push(aCx, false));
  JSAutoRequest ar(aCx);
  JSAutoEnterCompartment ac;
  NS_ENSURE_STATE(ac.enter(aCx, obj));
  nsCOMPtr<nsIMouseEventInit> dict;
  nsContentUtils::XPConnect()->WrapJS(aCx, obj,
                                      NS_GET_IID(nsIMouseEventInit),
                                      getter_AddRefs(dict));
  NS_ENSURE_TRUE(dict, NS_OK);
  return MouseEventInit_InitInternal(*this, dict, aCx, obj);
}

static nsresult
IDBObjectStoreParameters_InitInternal(IDBObjectStoreParameters& aDict, nsIIDBObjectStoreParameters* aIfaceObject, JSContext* aCx, JSObject* aObj)
{
  JSBool found = PR_FALSE;
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_keyPath, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetKeyPath(&(aDict.keyPath));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_autoIncrement, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetAutoIncrement(&(aDict.autoIncrement));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  return NS_OK;
}

nsresult
IDBObjectStoreParameters::Init(JSContext* aCx, const jsval* aVal)
{
  if (!aCx || !aVal) {
    return NS_OK;
  }
  NS_ENSURE_STATE(aVal->isObject());

  JSObject* obj = &aVal->toObject();
  nsCxPusher pusher;
  NS_ENSURE_STATE(pusher.Push(aCx, false));
  JSAutoRequest ar(aCx);
  JSAutoEnterCompartment ac;
  NS_ENSURE_STATE(ac.enter(aCx, obj));
  nsCOMPtr<nsIIDBObjectStoreParameters> dict;
  nsContentUtils::XPConnect()->WrapJS(aCx, obj,
                                      NS_GET_IID(nsIIDBObjectStoreParameters),
                                      getter_AddRefs(dict));
  NS_ENSURE_TRUE(dict, NS_OK);
  return IDBObjectStoreParameters_InitInternal(*this, dict, aCx, obj);
}

static nsresult
IDBIndexParameters_InitInternal(IDBIndexParameters& aDict, nsIIDBIndexParameters* aIfaceObject, JSContext* aCx, JSObject* aObj)
{
  JSBool found = PR_FALSE;
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_unique, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetUnique(&(aDict.unique));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  NS_ENSURE_STATE(JS_HasPropertyById(aCx, aObj, gDictionary_id_multiEntry, &found));
  if (found) {
    nsresult rv = aIfaceObject->GetMultiEntry(&(aDict.multiEntry));
    NS_ENSURE_SUCCESS(rv, rv);
  }
  return NS_OK;
}

nsresult
IDBIndexParameters::Init(JSContext* aCx, const jsval* aVal)
{
  if (!aCx || !aVal) {
    return NS_OK;
  }
  NS_ENSURE_STATE(aVal->isObject());

  JSObject* obj = &aVal->toObject();
  nsCxPusher pusher;
  NS_ENSURE_STATE(pusher.Push(aCx, false));
  JSAutoRequest ar(aCx);
  JSAutoEnterCompartment ac;
  NS_ENSURE_STATE(ac.enter(aCx, obj));
  nsCOMPtr<nsIIDBIndexParameters> dict;
  nsContentUtils::XPConnect()->WrapJS(aCx, obj,
                                      NS_GET_IID(nsIIDBIndexParameters),
                                      getter_AddRefs(dict));
  NS_ENSURE_TRUE(dict, NS_OK);
  return IDBIndexParameters_InitInternal(*this, dict, aCx, obj);
}

